



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Runtime之方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Runtime之方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 10:40:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前两篇介绍了类与对象、成员变量&amp;属性&amp;关联对象的相关知识，本篇我们将开始讲解Runtime中最有意思的一部分内容：消息处理机制。我们从一个示例开始。</p>
<p>在OC中，我们使用下面这种方式来调用方法：</p>
<div>
<pre class="prettyprint linenums">GofTest *test = [[GofTest alloc] init];<br />[test eat];</pre>
</div>
<p>对上面的方法调用，我们用Runtime的消息发送机制改造一下：</p>
<div>
<pre class="prettyprint linenums">id test = <strong>objc_msgSend</strong>(<strong>objc_getClass</strong>("GofTest"), <strong>sel_registerName</strong>("alloc"));<br />
objc_msgSend(test, sel_registerName("init"));<br />
objc_msgSend(test, sel_registerName("eat"));</pre>
</div>
<p>对于上面的结果，我们来验证一下：</p>
<div>
<pre class="prettyprint linenums">//cd到目录，执行如下指令<br />
clang -rewrite-objc main.m</pre>
</div>
<p>上面的<a href="https://github.com/oxnz/clang-user-manual/wiki/Clang-%E4%B8%AD%E6%96%87%E7%94%A8%E6%88%B7%E6%89%8B%E5%86%8C" rel="external nofollow noreferrer">Clang指令</a>可以将 Objetive-C 的源码改写成 C 语言的，打开目录，可以看到多了一个main.cpp文件。打开main.cpp文件，这个文件有将近10W行代码，我们翻到最下面，看main函数：</p>
<div>
<pre class="prettyprint linenums">#ifndef _REWRITER_typedef_GofTest<br />
#define _REWRITER_typedef_GofTest<br />
typedef struct objc_object GofTest;<br />
typedef struct {} _objc_exc_GofTest;<br />
#endif

struct GofTest_IMPL {<br />
    struct NSObject_IMPL NSObject_IVARS;<br />
};

// - (void)eat;

/* @end */

int main(int argc, char * argv[]) {<br />
    /* @autoreleasepool */ { __AtAutoreleasePool __autoreleasepool;<br />
        GofTest *test = ((GofTest *(*)(id, SEL))(void *)objc_msgSend)((id)((GofTest *(*)(id, SEL))(void *)objc_msgSend)((id)objc_getClass("GofTest"), sel_registerName("alloc")), sel_registerName("init"));<br />
        ((void (*)(id, SEL))(void *)objc_msgSend)((id)test, sel_registerName("eat"));<br />
    }<br />
    return ;<br />
}</pre>
</div>
<p>去掉类型强制转换，我们再来分析一下：</p>
<div>
<pre class="prettyprint linenums">int main(int argc, char * argv[]) {<br />
   { __AtAutoreleasePool __autoreleasepool;<br />
        GofTest *test = objc_msgSend(objc_msgSend(objc_getClass("GofTest"), sel_registerName("alloc")), sel_registerName("init"));<br />
        objc_msgSend(test, sel_registerName("eat"));<br />
    }<br />
    return ;<br />
}</pre>
</div>
<p>通过查看C语言代码，我们得出一个初步结论：<strong>使用objc_msgSend函数，给objc_getClass函数实例化的对象发送sel_registerName获取到的方法的消息</strong>。</p>
<p>在Runtime中，<code>objc_msgSend</code>这个方法是用汇编实现的，这是为了提升方法执行时的效率，因为几乎每个方法调用在内部都是通过<code>objc_msgSend</code>来完成的。为了进一步提升这个方法的效率，苹果还对每个类的方法做了缓存，当一个方法被调用过之后，它的IMP会被缓存在cache列表里，这样当再次调用该方法时，就可以很快地从缓存中取出，而不用再走一次完整的查找流程。</p>
<p>上面示例涉及到的SEL、objc_msgSend等内容，我们在下面会一一介绍。</p>
<p>【说明】：从Xcode 5.0开始，苹果不建议直接使用底层的消息发送机制，因此需要关掉下面的这个开关。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/992921/201704/992921-20170407102936050-1989343652.png" /></p>
<p>看完上面的示例后，我们来了解几个基本类型。</p>
<h1>1.基本类型</h1>
<h2>1.1SEL</h2>
<p>SEL又叫选择器，是表示一个方法的<code>selector</code>的指针，其定义如下：</p>
<div>
<pre class="prettyprint linenums">typedef struct objc_selector *SEL;

struct objc_selector<br />
{<br />
  void *sel_id;<br />
  const char *sel_types;<br />
};</pre>
</div>
<p>方法的<code>selector</code>用于表示运行时方法的名字。Objective-C在编译时，会根据每一个方法的名字、参数序列，生成一个唯一的整型标识(Int类型的标识)，这个标识就是<code>SEL</code>。</p>
<div>
<pre class="prettyprint linenums">SEL sel = @selector(alloc);<br />
NSLog(@"sel : %p", sel);  //打印结果  sel : 0x103e719b2</pre>
</div>
<p>两个类之间，<strong>只要方法名相同，那么方法的SEL就是一样的</strong>。每一个方法都对应着一个SEL，所以<strong>在Objective-C同一个类(及类的继承体系)中，不能存在2个同名的方法</strong>，即使参数类型不同也不行。相同的方法只能对应一个SEL。这也就导致Objective-C在处理相同方法名且参数个数相同但类型不同的方法方面的能力很差。</p>
<p>当然，不同的类可以拥有相同的Selector，这个没有问题。不同的类的实例对象执行相同的Selector时，会在各自的方法列表中根据Selector去寻找自己对应的IMP。</p>
<p>工程中的所有SEL组成一个Set集合，如果我们想到这个方法集合中查找某个方法时，只需要找到这个方法对应的SEL就行了，SEL实际上就是根据方法名hash化了的一个字符串，而对于字符串的比较仅仅需要比较它们的地址就可以了。</p>
<p>本质上，<strong>SEL只是一个指向方法的指针</strong>（准确的说，只是一个根据方法名hash化了的KEY值，能唯一代表一个方法），它的存在只是为了加快方法的查询速度。</p>
<p>我们可以通过下面三种方法来获取SEL：</p>
<div>
<pre class="prettyprint linenums">//编译器提供<br />
<strong>@selector()

</strong>//Runtime方法<br />
OBJC_EXPORT SEL <strong>sel_registerName</strong>(const char *str)<br />
    OBJC_AVAILABLE(10.0, 2.0, 9.0, 1.0);

//OC方法<br />
FOUNDATION_EXPORT SEL <strong>NSSelectorFromString</strong>(NSString *aSelectorName);</pre>
</div>
<p>示例如下：</p>
<div>
<pre class="prettyprint linenums">        SEL sel =<strong> @selector</strong>(alloc);<br />
        NSLog(@"sel : %p", sel);  //打印结果  sel : 0x103e719b2<br />
        id test = objc_msgSend(objc_getClass("GofTest"), <strong>sel_registerName</strong>("alloc"));<br />
        objc_msgSend(test, sel_registerName("init"));<br />
        objc_msgSend(test, <strong>NSSelectorFromString</strong>(@"eat"));</pre>
</div>
<h2>1.2IMP</h2>
<p>IMP实际上是一个函数指针，指向方法实现的首地址。其定义如下：</p>
<div>
<pre class="prettyprint linenums">#if !OBJC_OLD_DISPATCH_PROTOTYPES<br />
typedef void (*IMP)(void /* id, SEL, ... */ );<br />
#else<br />
typedef id (*IMP)(id, SEL, ...);<br />
#endif</pre>
</div>
<p>这个函数的第一个参数是指向self的指针（如果是实例方法，则是类实例的内存地址；如果是类方法，则是指向元类的指针），第二个参数是方法选择器（selector），接下来是方法的实际参数列表。</p>
<p>前面介绍过的SEL就是为了查找方法的最终实现IMP的。由于每一个方法对应唯一的SEL，因此我们可以通过SEL方便快速准确地获得它所对应的IMP，查找过程将在下面讨论。取得IMP后，我们就获得了执行这个方法代码的入口点，此时，我们就可以像调用普通的C语言函数一样来使用这个函数指针了。</p>
<p>通过取得IMP，我们可以跳过Runtime的消息传递机制，直接执行IMP指向的函数实现，这样省去了Runtime消息传递过程中所做的一系列查找操作，会比直接向对象发送消息高效一些。</p>
<h2>1.3Method</h2>
<p>Method用于表示类定义的方法，定义如下：</p>
<div>
<pre class="prettyprint linenums">typedef struct objc_method *Method;

struct objc_method {<br />
    SEL method_name                                          OBJC2_UNAVAILABLE;  //方法名<br />
    char *method_types                                       OBJC2_UNAVAILABLE;<br />
    IMP method_imp                                           OBJC2_UNAVAILABLE;  //方法实现<br />
}  </pre>
</div>
<p>从定义可以看到，结构体中包含一个SEL和IMP，实际上相当于在SEL和IMP之间作了一个映射。有个SEL，我们便可以找到对应的IMP，从而调用方法的实现代码。</p>
<h1>2.相关操作函数</h1>
<p>Runtime提供了一系列的方法来处理与方法相关的操作。包括方法本身及SEL。</p>
<div>
<pre class="prettyprint linenums">//调用指定方法的实现<br />
OBJC_EXPORT id <strong>method_invoke</strong>(id receiver, Method m, ...)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//调用返回一个数据结构的方法的实现<br />
OBJC_EXPORT void<strong> method_invoke_stret</strong>(id receiver, Method m, ...)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0)<br />
    OBJC_ARM64_UNAVAILABLE;<br />
//获取方法名<br />
OBJC_EXPORT SEL <strong>method_getName</strong>(Method m)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//返回方法的实现<br />
OBJC_EXPORT IMP <strong>method_getImplementation</strong>(Method m)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//获取描述方法参数和返回值类型的字符串<br />
OBJC_EXPORT const char *<strong>method_getTypeEncoding</strong>(Method m)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//获取方法的返回值类型的字符串<br />
char *<strong> method_copyReturnType</strong> ( Method m );<br />
//获取方法的指定位置参数的类型字符串<br />
OBJC_EXPORT char *<strong>method_copyArgumentType</strong>(Method m, unsigned int index)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//通过引用返回方法的返回值类型字符串<br />
OBJC_EXPORT void <strong>method_getReturnType</strong>(Method m, char *dst, size_t dst_len)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//返回方法的参数的个数<br />
OBJC_EXPORT unsigned int<strong> method_getNumberOfArguments</strong>(Method m)<br />
    OBJC_AVAILABLE(10.0, 2.0, 9.0, 1.0);<br />
//通过引用返回方法指定位置参数的类型字符串<br />
OBJC_EXPORT void <strong>method_getArgumentType</strong>(Method m, unsigned int index,<br />
                                        char *dst, size_t dst_len)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//返回指定方法的方法描述结构体<br />
OBJC_EXPORT struct objc_method_description *<strong>method_getDescription</strong>(Method m)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//设置方法的实现<br />
OBJC_EXPORT IMP <strong>method_setImplementation</strong>(Method m, IMP imp)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//交换两个方法的实现<br />
OBJC_EXPORT void<strong> method_exchangeImplementations</strong>(Method m1, Method m2)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);<br />
//返回给定选择器指定的方法的名称<br />
OBJC_EXPORT const char *<strong>sel_getName</strong>(SEL sel)<br />
    OBJC_AVAILABLE(10.0, 2.0, 9.0, 1.0);<br />
//在Objective-C Runtime系统中注册一个方法，将方法名映射到一个选择器，并返回这个选择器。<br />//【说明】：所谓的注册，就是把一个methodName映射到一个selector并返回selecor; 如果已经注册则直接返回selector<br />
OBJC_EXPORT SEL <strong>sel_registerName</strong>(const char *str)<br />
    OBJC_AVAILABLE(10.0, 2.0, 9.0, 1.0);<br />
//在Objective-C Runtime系统中注册一个方法（objc.h）<br />
OBJC_EXPORT SEL <strong>sel_getUid</strong>(const char *str)<br />
    OBJC_AVAILABLE(10.0, 2.0, 9.0, 1.0);<br />
//比较两个选择器<br />
OBJC_EXPORT BOOL <strong>sel_isEqual</strong>(SEL lhs, SEL rhs)<br />
    OBJC_AVAILABLE(10.5, 2.0, 9.0, 1.0);</pre>
</div>
<p>使用示例如下所示：</p>
<div>
<pre class="prettyprint linenums">    GofPerson *person = [[GofPerson alloc] init];<br />
    Class objectClsObj = object_getClass(person);

    //1.注册方法(这里的注册，就是把一个methodName映射到一个selector并返回selecor; 如果已经注册则直接返回selector)<br />
    //留意一下，如果方法名称相同，则返回的SEL也是一样的<br />
    SEL sel_register = <strong>sel_registerName</strong>("registerNewMethod");<br />
    SEL sel_register2 = <strong>sel_getUid</strong>("registerNewMethod");

    //2.比较两个SEL<br />
    if (<strong>sel_isEqual</strong>(sel_register, sel_register2)) {<br />
        NSLog(@"相同的SEL");<br />
    }<br />
    else<br />
    {<br />
        NSLog(@"不同的SEL");<br />
    }

    //3.获取实例方法<br />
    Method instanceMethod = <strong>class_getInstanceMethod</strong>([GofPerson class], @selector(doWork:));  //如果指定的SEL不存在,那么返回Nil<br />
    //objc_msgSend、objc_msgSendSuper、method_invoke(有返回值)都用于消息发送<br />
    //objc_msgSend_stret、objc_msgSend_fpret函数是这三者的变体<br />
    //当返回的是结构体、浮点数时，会调用类似_stret、_fpret的方法<br />
    NSString *strRet = <strong>method_invoke</strong>(person, instanceMethod, @"看书");  //调用方法<br />
    NSLog(@"method_invoke 执行方法结果：%@", strRet);<br />
    SEL sel_instanceMethod = <strong>method_getName</strong>(instanceMethod);  //获取SEL<br />
    NSLog(@"实例方法名称：%s", <strong>sel_getName</strong>(sel_instanceMethod));  //获取方法名称

    //4.获取类方法<br />
    Method classMethod =<strong> class_getClassMethod</strong>(objectClsObj, @selector(createPersonWithName:age:));<br />
    SEL sel_classMethod = <strong>method_getName</strong>(classMethod);  //获取SEL<br />
    NSLog(@"类方法名称：%s", <strong>sel_getName</strong>(sel_classMethod));  //获取方法名称

    //5.获取实例方法列表<br />
    unsigned int count_instanceMethod = ;<br />
    Method *instanceMethodList = <strong>class_copyMethodList</strong>([GofPerson class], &amp;count_instanceMethod);<br />
    for (int i = ; i &lt; count_instanceMethod; i++)<br />
    {<br />
        Method method = instanceMethodList[i];<br />
        SEL sel_Method =<strong> method_getName</strong>(method);<br />
        const char *returnType = <strong>method_copyReturnType</strong>(method);  //方法返回值类型<br />
        NSLog(@"实例方法%d:%@ 返回值类型：%s", i, NSStringFromSelector(sel_Method), returnType);<br />
    }<br />
    free(instanceMethodList);

    //6.获取类方法列表<br />
    unsigned int count_classMethod = ;<br />
    Method *classMethodList = <strong>class_copyMethodList</strong>(object_getClass([GofPerson class]), &amp;count_classMethod);<br />
    for (int i = ; i &lt; count_classMethod; i++)<br />
    {<br />
        Method method = classMethodList[i];<br />
        SEL sel_Method =<strong> method_getName</strong>(method);<br />
        const char *methodType = <strong>method_getTypeEncoding</strong>(method);// 获取方法参数类型和返回类型<br />
        NSLog(@"类方法%d:%@  方法类型：%s", i, NSStringFromSelector(sel_Method), methodType);<br />
    }<br />
    free(classMethodList);

    //7.获取方法相关信息<br />
    Method methodTest =<strong> class_getClassMethod</strong>(objectClsObj, @selector(createPersonWithName:age:));<br />
    //获取方法返回值类型<br />
    const char* method_ReturnType =<strong> method_copyReturnType</strong>(methodTest);<br />
    NSLog(@"方法返回值类型:%@",[NSString stringWithUTF8String:method_ReturnType]);<br />
    //获取方法参数个数<br />
    unsigned int numberOfArguments =<strong> method_getNumberOfArguments</strong>(methodTest);<br />
    NSLog(@"方法参数个数:%d",numberOfArguments);<br />
    char argName[] = {};<br />
    for ( int i = ; i &lt; numberOfArguments ; i ++)<br />
    {<br />
        //获取方法参数类型方式1<br />
        <strong>method_getArgumentType</strong>(methodTest, i, argName, );<br />
        NSLog(@"方式1统计参数%d类型:%s", i, argName);<br />
        memset(argName, '\0', strlen(argName));<br />
        //获取方法参数类型方式2<br />
        const char *type =<strong> method_copyArgumentType</strong>(methodTest, i);<br />
        NSLog(@"方式2统计参数%d类型:%@", i, [NSString stringWithUTF8String:type]);<br />
    }<br />
    //获取方法描述<br />
    struct objc_method_description *method_descriptions =<strong> method_getDescription</strong>(methodTest);<br />
    struct objc_method_description method_description = method_descriptions[];<br />
    SEL sel_des = method_description.name;<br />
    const char *type_des = method_description.types;<br />
    NSLog(@"方法描述 名称:%@  类型:%@",NSStringFromSelector(sel_des),[NSString stringWithUTF8String:type_des]);

    //8.交换方法实现<br />
    SEL originalSelector = @selector(doWork:);<br />
    SEL swizzledSelector = @selector(sayHello:);<br />
    Method originalMethod = class_getInstanceMethod(objectClsObj, originalSelector);<br />
    Method swizzledMethod = class_getInstanceMethod(objectClsObj, swizzledSelector);<br />
    <strong>method_exchangeImplementations</strong>(originalMethod, swizzledMethod);<br />
//    if (!originalMethod || !swizzledMethod) {<br />
//        return;<br />
//    }<br />
//<br />
//    IMP originalIMP = method_getImplementation(originalMethod);<br />
//    IMP swizzledIMP = method_getImplementation(swizzledMethod);<br />
//    const char *originalType = method_getTypeEncoding(originalMethod);<br />
//    const char *swizzledType = method_getTypeEncoding(swizzledMethod);

    // 这儿的先后顺序是有讲究的,如果先执行后一句,那么在执行完瞬间方法被调用容易引发死循环<br />
//    class_replaceMethod(objectClsObj, swizzledSelector, originalIMP, originalType);<br />
//    class_replaceMethod(objectClsObj, originalSelector, swizzledIMP, swizzledType);<br />
    [person doWork:@"吃饭"];<br />
    [person sayHello:@"Gof"];</pre>
</div>
<h1>3.方法调用流程</h1>
<p>在本篇开始，我们知道在Runtime中，编译器会把OC的消息表达式<code>[receiver message]</code>转化为一个消息函数的调用，即<strong><code>objc_msgSend</code></strong>，这个函数将消息接收者和方法名作为其基础参数。</p>
<p>这个函数完成了动态绑定的所有事情：</p>
<ol><li>首先它找到selector对应的方法实现。因为同一个方法可能在不同的类中有不同的实现，所以需要依赖接收者的类来找到确切的实现。</li>
<li>它调用方法实现，并将接收者对象及方法的所有参数传给它。</li>
<li>最后，它将实现返回的值作为它自己的返回值。</li></ol>
<p>当我们创建一个新对象时，先为其分配内存，并初始化其成员变量。其中isa指针也会被初始化，让对象可以访问类及类的继承体系。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/992921/201704/992921-20170411181011626-1519652267.png" /></p>
<p>当消息发送给一个对象时，<code>objc_msgSend</code>通过对象的isa指针获取到类的结构体，然后在方法分发表里面查找方法的selector。如果没有找到selector，则通过<code>objc_msgSend</code>结构体中的指向父类的指针找到其父类，并在父类的分发表里面查找方法的selector。依此，会一直沿用类的继承体系到达NSObject类。一旦定位到selector，函数就获取到了实现的入口点，并传入相应的参数来执行方法的具体实现。如果最后没有定位到selector，则会走消息转发流程，这个后面会介绍。为了加速消息的处理，运行时系统缓存使用过的selector及对应的方法的地址。</p>
<h2>3.1隐藏参数</h2>
<p><code>objc_msgSend</code>有两个隐藏参数：</p>
<ol><li>消息接收对象</li>
<li>方法的selector</li></ol>
<p>这两个参数为方法的实现提供了调用者的信息。之所以说是隐藏的，是因为它们在定义方法的源代码中没有声明。它们是在编译器被插入实现代码的。</p>
<p>虽然这些参数没有显示声明，但在代码中仍然可以引用它们。我们可以使用<strong>self</strong>来引用接收者对象，使用<strong><code>_cmd</code></strong>来引用选择器。例如：</p>
<div>
<pre class="prettyprint linenums">- (NSString *)sayHello:(NSString *)name {<br />
    NSLog(@"Hello %s", sel_getName(_cmd));<br />
    return name;<br />
}</pre>
</div>
<p>在实际开发中，我们用的比较多的是self，<code>_cmd</code>用的比较少。</p>
<h2>3.2获取方法地址</h2>
<p>Runtime中方法的动态绑定让我们写代码时更具灵活性。如我们可以把消息转发给我们想要的对象，或者随意交换一个方法的实现等。不过灵活性的提升也带来了性能上的一些损耗。毕竟我们需要去查找方法的实现，而不像函数调用来的那么直接。</p>
<p>NSObject类提供了<code>methodForSelector:</code>方法，让我们可以获取到方法的指针，然后通过这个指针来调用实现代码。 使用示例如下：</p>
<div>
<pre class="prettyprint linenums">    GofPerson *person = [[GofPerson alloc] init];

    IMP methodImplement = [person <strong>methodForSelector</strong>:@selector(sayHi)];<br />
    for (int i = ; i &lt; ; i++) {<br />
        methodImplement(self, @selector(sayHi));<br />
    }</pre>
</div>
<p>【注意】：sayHi即使是私有方法(在.h文件中没有暴露接口)，也可以调用成功。</p>
<h1>4.消息转发</h1>
<p>当一个对象能响应一个消息时，就会走正常的方法调用流程。但如果一个对象无法响应指定的消息时，会发生什么事呢？</p>
<p>默认情况下，如果是以<code>[object message]</code>的方式调用方法，如果<code>object</code>无法响应<code>message</code>消息时，编译器会报错。但如果是以<code>perfrom...</code>的形式来调用，则需要等到运行时才能确定object是否能<code>响应</code>消息。如果不能，则程序崩溃。</p>
<p>通常，当我们不能确定一个对象是否能接收某个消息时，会先调用<code>respondsToSelector:</code>来判断一下。使用示例如下：</p>
<div>
<pre class="prettyprint linenums">    GofPerson *person = [[GofPerson alloc] init];<br />
    [person performSelector:@selector(test)];</pre>
</div>
<p>本节我们不讨论使用respondsToSelector判断的情况，来谈一个新的机制：<strong>消息转发机制</strong>。</p>
<p>当一个对象无法接收某一消息时，就会启动所谓消息转发机制。通过这一机制，我们可以告诉对象如何处理未知的消息。默认情况下，对象接收到未知的消息，会导致程序崩溃，通过控制台，我们可以看到以下异常信息：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/992921/201704/992921-20170411205710938-77454361.png" /></p>
<p>这段异常信息实际上是由NSObject的<strong><code>doesNotRecognizeSelector</code></strong>方法抛出来的。不过，我们可以采取一些措施，让我们的程序执行特定的逻辑，而避免程序的崩溃。</p>
<p>消息转发机制基本上分为三个步骤：</p>
<ol><li>动态方法解析</li>
<li>备用接收者</li>
<li>完整转发</li></ol>
<h2>4.1动态方法解析</h2>
<p>对象在接收到未知的消息时，首先会调用所属类的类方法<code>+resolveInstanceMethod:</code>(实例方法)或者<code>+resolveClassMethod:</code>(类方法)，这两个方法是NSObject根类提供的类方法，调用时机为<strong>当被调用的方法实现部分没有找到，而消息转发机制启动之前的这个中间时刻</strong>。在这个方法中，我们有机会为该未知消息新增一个&ldquo;处理方法&rdquo;。不过使用该方法的前提是我们已经实现了该&ldquo;处理方法&rdquo;，只需要在运行时通过<code>class_addMethod</code>函数动态添加到类里面就可以了。示例代码如下：</p>
<div>
<pre class="prettyprint linenums">+ (BOOL)resolveInstanceMethod:(SEL)sel {<br />
    NSString *selectorString = NSStringFromSelector(sel);<br />
    if ([selectorString isEqualToString:@"test"]) {<br />
        <strong>class_addMethod</strong>(self.class, @selector(test), (IMP)testImplement, "@:");<br />
    }<br />
    return [super resolveInstanceMethod:sel];<br />
}

void testImplement() {<br />
    NSLog(@"TEST");<br />
}</pre>
</div>
<h2>4.2备用接收者</h2>
<p>如果在上一步无法处理消息，则Runtime会继续调用方法<strong>forwardingTargetForSelector</strong>&nbsp;。如果一个对象实现了这个方法，并返回一个非nil得结果，则这个对象会作为消息的新接收者，且消息会被分发到这个对象。当然这个对象不能是<code>self</code>，否则会出现无限循环。当然，如果我们没有指定相应的对象来处理<code>消息</code>，则应该调用父类的实现来返回结果。示例代码如下：</p>
<div>
<pre class="prettyprint linenums">//GofPerson.m文件<br />
- (id)<strong>forwardingTargetForSelector</strong>:(SEL)aSelector {<br />
    NSLog(@"forwardingTargetForSelector");<br />
    NSString *selectorString = NSStringFromSelector(aSelector);<br />
    // 将消息转发给GofPersonReceiver来处理<br />
    if ([selectorString isEqualToString:@"test"]) {<br />
        return [[GofPersonReceiver alloc] init];<br />
    }<br />
    return [super forwardingTargetForSelector:aSelector];<br />
}

//新添加GofPersonReceiver类的.m文件<br />
@implementation GofPersonReceiver

- (void)test {<br />
    NSLog(@"GofPersonReceiver TEST");<br />
}

@end</pre>
</div>
<p>这里实际上是对消息指定了一个新的发送对象，将"test"转发给了这个GofPersonReceiver实例由它来相应这个消息。<em>这里的返回值就是需要相应这个消息的对象。</em></p>
<p>【注意】：这一步适合于我们只想将消息转发到另一个能处理该消息的对象上；但这一步无法对消息进行处理，如操作消息的参数和返回值。</p>
<h2>4.3完整消息转发</h2>
<p>如果在上一步还不能处理未知消息，则唯一能做的就是启用完整的消息转发机制了。此时会调用这个方法：&nbsp;<strong>forwardInvocation</strong>。</p>
<p>运行时系统会在这一步给消息接收者最后一次机会将消息转发给其他对象。<strong>对象会创建一个表示消息的NSInvocation对象，把与尚未处理的消息有关的全部细节都封装在<code>anInvocation</code>中，包括<code>selector</code>,目标（<code>target</code>）和参数。</strong>我们可以通过实现forwardInvocation:方法来对不能处理的消息做一些默认的处理，以避免程序崩溃，这个函数主要是用来将消息转发给其它对象。每一个对象都从NSObject类继承了forwardInvocation:方法，但在NSObject中，该方法只是简单的调用doesNotRecognizeSelector:，通过重写该方法我们就可以利用forwardInvocation:将消息转发给其它对象。</p>
<p><code>forwardInvocation</code>方法的实现有两个任务：</p>
<ol><li>定位可以响应封装在<code>anInvocation</code>中的消息对象。这个对象不需要能处理所有未知消息。</li>
<li>使用<code>anInvocation</code>作为参数，将消息发送给选中的对象。<code>anInvocation</code>将会保留调用结果，运行时系统会提取这一结果并将其发送到消息的原始发送者。</li></ol>
<p>不过，在这个方法中我们可以实现一些更复杂的功能，我们可以对消息的内容进行修改，比如追回一个参数等，然后再去出发消息。另外，若发现某个消息不应由本类处理，则应调用父类的同名方法，以便继承体系中的每个类都有机会处理此调用请求。</p>
<p>还有一个很重要的问题，我们必须重新写以下方法：</p>
<div>
<pre class="prettyprint linenums">- (NSMethodSignature *)methodSignatureForSelector:(SEL)aSelector OBJC_SWIFT_UNAVAILABLE("");</pre>
</div>
<p>消息转发机制使用从这个方法中获取的信息来创建<code>NSInvocation</code>对象。因此我们必须重写这个方法，为给定的selector提供一个合适的签名方法。通过重写methodSignatureForSelector:<strong>方法可以事先判断出另一个对象是不是真的能够响应将被转发的消息。如果返回NO，那么就不用执行forwardInvocation:方法了</strong>。</p>
<div>
<pre class="prettyprint linenums">- (NSMethodSignature *)methodSignatureForSelector:(SEL)aSelector {<br />
    NSMethodSignature *signature = [super methodSignatureForSelector:aSelector];<br />
    if (!signature) {<br />
        if ([GofPersonReceiver instancesRespondToSelector:aSelector]) {<br />
            signature = [GofPersonReceiver instanceMethodSignatureForSelector:aSelector];<br />
        }<br />
    }<br />
    return signature;<br />
}

- (void)forwardInvocation:(NSInvocation *)anInvocation {<br />
    if ([GofPersonReceiver instancesRespondToSelector:anInvocation.selector]) {<br />
        [anInvocation invokeWithTarget:[[GofPersonReceiver alloc] init]];<br />
    }<br />
}</pre>
</div>
<p>从某种意义上来讲，<code>forwardInvocation:</code>就像一个未知消息的分发中心，将这些未知的消息转发给其他对象。或者也可以像一个运输站一样将所有未知消息都发送给同一个接收对象。这取决于具体的实现。</p>
<h2>4.4消息转发小结</h2>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/992921/201704/992921-20170411214114954-1845520454.png" /></p>
<h1>5.方法交换(Method Swizzling)</h1>
<p>方法交换是一项异常强大的技术，它可以允许我们动态地替换方法的实现，实现&nbsp;<a href="https://github.com/steipete/Aspects" rel="external nofollow noreferrer"><code>Hook</code></a>&nbsp;功能，是一种比子类化更加灵活的&ldquo;重写&rdquo;方法的方式。</p>
<p>我们从一个页面统计的示例开始：</p>
<div>
<pre class="prettyprint linenums">#import "UIViewController+GofUMAnalytics.h"<br />
#import &lt;objc/message.h&gt;

@implementation UIViewController (GofUMAnalytics)

+ (void)load {<br />
    static dispatch_once_t onceToken;<br />
    dispatch_once(&amp;onceToken, ^{<br />
        Class class = [self class];

        SEL originalSelector = @selector(viewWillAppear:);<br />
        SEL swizzledSelector = @selector(gof_viewWillAppear:);

        Method originalMethod = class_getInstanceMethod(class, originalSelector);<br />
        Method swizzledMethod = class_getInstanceMethod(class, swizzledSelector);

        BOOL success = <strong>class_addMethod</strong>(class, originalSelector, method_getImplementation(swizzledMethod), method_getTypeEncoding(swizzledMethod));<br />
        if (success) {<br />
            <strong>class_replaceMethod</strong>(class, swizzledSelector, method_getImplementation(originalMethod), method_getTypeEncoding(originalMethod));<br />
        } else {<br />
            <strong>method_exchangeImplementations</strong>(originalMethod, swizzledMethod);<br />
        }<br />
    });<br />
}

#pragma mark - Method Swizzling

- (void)gof_viewWillAppear:(BOOL)animated {<br />
    [self gof_viewWillAppear:animated];<br />
    //加友盟统计代码<br />
    NSLog(@"页面进入：%@", NSStringFromClass([self class]));<br />
}

@end</pre>
</div>
<p>看到上面的代码，大家可能存在这几个问题：</p>
<p><strong>1.为什么是在&nbsp;<code>+load</code>&nbsp;方法中实现 Method Swizzling 的逻辑，而不是其他的什么方法？</strong></p>
<p><code>+load</code>&nbsp;和&nbsp;<code>+initialize</code>&nbsp;是 Objective-C runtime 会自动调用的两个类方法。但是它们被调用的时机却是有差别的，<code>+load</code>&nbsp;方法是在类被加载的时候调用的，而&nbsp;<code>+initialize</code>&nbsp;方法是在类或它的子类收到第一条消息之前被调用的，这里所指的消息包括实例方法和类方法的调用。也就是说&nbsp;<code>+initialize</code>&nbsp;方法是以懒加载的方式被调用的，如果程序一直没有给某个类或它的子类发送消息，那么这个类的&nbsp;<code>+initialize</code>&nbsp;方法是永远不会被调用的。此外&nbsp;<code>+load</code>&nbsp;方法还有一个非常重要的特性，那就是子类、父类和分类中的&nbsp;<code>+load</code>&nbsp;方法的实现是被区别对待的。换句话说在 Objective-C runtime 自动调用&nbsp;<code>+load</code>&nbsp;方法时，分类中的&nbsp;<code>+load</code>&nbsp;方法并不会对主类中的&nbsp;<code>+load</code>&nbsp;方法造成覆盖。</p>
<p><strong>2.为什么 Method Swizzling 的逻辑需要用 dispatch_once 来进行调度？</strong></p>
<p>因为<code>swizzling</code>会改变全局状态，所以我们需要在运行时采取一些预防措施。原子性就是这样一种措施，它确保代码只被执行一次，不管有多少个线程。GCD的<code>dispatch_once</code>可以确保这种行为，我们应该将其作为<code>method swizzling</code>的最佳实践。</p>
<p><strong>3.为什么需要调用&nbsp;<code>class_addMethod</code>&nbsp;方法，并且以它的结果为依据分别处理两种不同的情况 ？</strong></p>
<p>我们使用 Method Swizzling 的目的通常都是为了给程序增加功能，而不是完全地替换某个功能，所以我们一般都需要在自定义的实现中调用原始的实现。</p>
<ul><li>情况一：主类本身有实现需要替换的方法，也就是<strong>&nbsp;<code>class_addMethod</code>&nbsp;方法返回&nbsp;<code>NO</code></strong>&nbsp;。这种情况的处理比较简单，直接使用method_exchangeImplementations交换两个方法的实现就可以了。</li>
<li>情况二：主类本身没有实现需要替换的方法，而是继承了父类的实现，即&nbsp;<code>class_addMethod</code>&nbsp;方法返回&nbsp;<code>YES</code>&nbsp;。这时使用&nbsp;<code>class_getInstanceMethod</code>&nbsp;函数获取到的&nbsp;<code>originalSelector</code>&nbsp;指向的就是父类的方法，我们再通过执行&nbsp;<code>class_replaceMethod(class, swizzledSelector, method_getImplementation(originalMethod), method_getTypeEncoding(originalMethod));</code>&nbsp;将父类的实现替换到我们自定义的&nbsp;<code>mrc_viewWillAppear</code>&nbsp;方法中。这样就达到了在&nbsp;<code>mrc_viewWillAppear</code>&nbsp;方法的实现中调用父类实现的目的。</li></ul>
<p>【注意】：</p>
<p>Swizzling通常被称作是一种黑魔法，容易产生不可预知的行为和无法预见的后果。因此在使用时需要注意如下地方：</p>
<ol><li>总是调用方法的原始实现(除非有更好的理由不这么做)：API提供了一个输入与输出约定，但其内部实现是一个黑盒。Swizzle一个方法而不调用原始实现可能会打破私有状态底层操作，从而影响到程序的其它部分。</li>
<li>避免冲突：给自定义的分类方法加前缀，从而使其与所依赖的代码库不会存在命名冲突。</li>
<li>明白是怎么回事：简单地拷贝粘贴swizzle代码而不理解它是如何工作的，不仅危险，而且会浪费学习Objective-C运行时的机会。</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlj2ex9.html">微信小程序开发&mdash;快速掌握组件及API的方法---转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/495yvd6q.html">AngularJs ngInclude、ngTransclude</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwpggy8.html">&lbrack;转&rsqb;OpenVPN 安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxy5k9.html">c&plus;&plus;学习笔记&mdash;&mdash;构造函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxg3j9.html">WebView加载本地Html文件并实现点击效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0n3w0q.html">IOS开发之路四（UITabBarController）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vyvm38.html">Linux编译安装Darwin Streaming Server 6&period;0&period;3。。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdg3zz8.html">C&plus;&plus;拾遗（五）语句相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15o7xq.html">struts2--配置文件中使用通配符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v4joq.html">Java与C&sol;C&plus;&plus;有什么区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnge59.html">easyUI draggable组件使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljd7je9.html">Centos7安装openvpn及客户端配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zv6ne9.html">洞见世界&lpar;1&rpar;&colon; 拉勾网大数据告诉你&comma; 会计最高月薪达33k&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pw3wn8.html">ubuntu14&period;04系统中virtualbox安装Oracle VM VirtualBox Extension Pack包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnwpe9.html">c&plus;&plus; string 转double</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6wpeq.html">数据库开源框架GreenDao的使用解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyxdgd9.html">MT【226】费马点两题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvy6v38.html">Spring MVC POM示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv6v6y8.html">maven打包之后为什么class文件中没有注释了？</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1opo69.html">window下node更新</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7o0m6g8.html">&amp;lt&semi;记录&amp;gt&semi; curl 封装函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjrexl9.html">关于游览器 cookie的操作类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1lj65q.html">使用appium做自动化测试时，send&lowbar;keyss只能输入字母数字，无法输入中文</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wgw3zq.html">LevelDB源码分析-TableBuilder生成sstable</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rj76q.html">vue浏览器滚动加载更多</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1dez09.html">python入门（一）：进入python的交互模式、pip的使用和数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4r54k9.html">十一、Composite 组合模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o0ln18.html">H5相关网址</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1d21w9.html">&commat;RequestBody配合&commat;JsonFormat注解实现字符串自动转换成Date</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdz5ov9.html">419&period; Battleships in a Board 棋盘上的战舰数量</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
